﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Reflection;

namespace Persistence {
  public class Util {
    public static string AutoFormat(object o) {
      return AutoFormat(o, false);
    }
    public static string AutoFormat(object o, bool recursive) {
      string s = o as string;
      if (s != null)
        return s;
      if (o == null) {
        return "<null>";
      }
      StringBuilder sb = new StringBuilder();
      sb.Append(o.GetType().Name);
      sb.Append("(");
      foreach (MemberInfo mInfo in o.GetType().GetMembers(
        BindingFlags.Public |
        BindingFlags.NonPublic |
        BindingFlags.Instance)) {
        if (mInfo.MemberType == MemberTypes.Field) {
          sb.Append(mInfo.Name);
          sb.Append("=");
          if (recursive) {
            sb.Append(AutoFormat(((FieldInfo)mInfo).GetValue(o)));
          } else {
            sb.Append(((FieldInfo)mInfo).GetValue(o));
          }
          sb.Append(", ");
        }
      }
      sb.Remove(sb.Length - 2, 2);
      sb.Append(")");
      return sb.ToString();
    }
  }
}
